addpath(['./program'])
%set(0,'DefaultLineLineWidth',2,'DefaultAxesFontSize',12,'DefaultAxesFontName','Arial');
set(0,'DefaultAxesFontSize',12,'DefaultAxesFontName','Arial');
%data_dir='C:\Users\skaufmann\Downloads\';
data_dir='.\data\';
shade_events=kron([2000+2/12 2001+8/12; 2008+8/12 2009+3/12 ; 2011+7/12 2011+8/12; 2015 2015+1/12]'-1/24,ones(2,1));
shade_no=size(shade_events,2);
shade_corona=kron([2020 2020.5]'-1/8,ones(2,1));
shadeC_color=[1 0 0];
shadeC_no=size(shade_corona,2);

% shade_color=[.9 .9 .9];
shade_color=[0 0 0];
Fvalue=0.1;
x_lim=6/12;
Flsize=12;

dataf_pdf='DE_Abgerechnete_Kurzarbeit_ab_2000.xlsx';
dataf_dload='2205_Abgerechnete_Kurzarbeit_ANehmer.xlsx';
dataf_dloadStunden='2205_Abgerechnete_Kurzarbeit_Ausfallst.xlsx';
dataf_secw='STATENT_nach_NOGA3_2022_06_20.xlsx';
%dataf_voranm='2020Voranmka.xlsx';
sheet='Kantone';
%dataf_bci='snb_bcindex.xlsx';
dataf_seco='2202_realtime_database.xlsx';
%sheet_nom='nom_q';
sheet_real='gdp';
sheet_defl='gdp_d';

cal_orig=2000:1/12:2022+1/12;

[data,ser]=xlsread([data_dir dataf_dload],'realtime');
data_dload=data;%[data(1:end-1,:) sum(data(1:end-1,:),2)];%;reshape(data,3,size(data,2)/3)';
calb_dload=2004;
cale_dload=2022+1/12;
cal_dload=calb_dload:1/12:cale_dload;
calb_dvint=2020+2/12;
cale_dvint=2022+3/12;
cal_dvint=calb_dvint:1/12:cale_dvint;

ser_dload=ser(1,2:end);
%ser_dload=cat(2,ser_dload, 'Total');
[data,ser]=xlsread([data_dir dataf_dloadStunden]);
data_dloadStunden=[data(1:end-1,:) sum(data(1:end-1,:),2)];%;reshape(data,3,size(data,2)/3)';

clear data ser

[data,ser]=xlsread([data_dir dataf_dload],'1 Abgerechnete Kurzarbeit');
data_sect=data(4:end-1,:);
ser_sect=ser(8,3:end);
ser_class=ser(6,3:end);
ser_code=ser(7,3:end);
ser_code{1}='00';
indYTick=find([1==1 ~strcmp(ser_class(2:end),ser_class(1:end-1))]);
indc_ser=ser_class([1==1 ~strcmp(ser_class(2:end),ser_class(1:end-1))]);

[datas,sers]=xlsread([data_dir dataf_secw]);
data_secw=datas(:,3:4); %VZ?; Besch?ftigte
data_secw(isnan(data_secw))=0;
ser_secw=sers(8:end,2);
serab_secw=char(ser_secw);
serab_secw=cellstr(serab_secw(:,1:2));

vza_tot=sum(data_secw(:,1));
emp_tot=sum(data_secw(:,2));
ser_weight=zeros(1,length(ser_code));
vza=1;
for wj=1:length(ser_code)
    if any(ismember(serab_secw,ser_code{wj}))
        if vza
            ser_weight(wj)= sum(data_secw(ismember(serab_secw,ser_code{wj}),1))./vza_tot;
        else
            ser_weight(wj)= sum(data_secw(ismember(serab_secw,ser_code{wj}),2))./emp_tot;
        end
    else
        ser_weight(wj)=0;
    end
end


% [data2,ser2]=xlsread([data_dir dataf_voranm]);
% data2rel=data2(end,1:4)';
% ser_voranm=ser2{3,2};
% data_voranm=data2rel;
% %data_voranm(end-length(data2rel)+1:end,3)=data2rel;
% calb_voranm=2020;
% cale_voranm=cal_orig(end);
% clear data2 ser2

[data3,ser3]=xlsread([data_dir dataf_pdf]);
data_pdf=data3;
calb_pdf=2000;
cale_pdf=2020;
ser_pdf=ser3{3,2:4};
clear data3 ser3

[data4,ser4]=xlsread([data_dir dataf_seco],'gdp');
data_bip=data4;
calb_bip=1980;%data4(1,1)+(data4(1,2)-1)./4;
cale_bip=2021.75;%data4(end,1)+(data4(end,2)-1)./4;
cal_bip=calb_bip:.25:cale_bip;
calb_bipvint=2000.25;
cale_bipvint=2022;
cal_bipvint=calb_bipvint:.25:cale_bipvint;
% [data4,ser4]=xlsread([data_dir dataf_seco],'real_q');
% data_bip(:,2)=data4(:,3);
ser_bip={'GDP real'};
clear data4 ser4

% [data5,ser5]=xlsread([data_dir dataf_bci]);
% data_bci=data5(:,1);
% calb_bci=1990;
% cale_bci=2020+1/12;
% cal_bci=calb_bci:1/12:cale_bci;
% ser_bci='SNB bcindex'
% clear data5 ser5

data_long_orig=zeros(length(cal_orig),2).*NaN;
data_long_orig((and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),:)=data_pdf(:,2:3);
data_long_orig((and(cal_orig>=calb_dload,cal_orig<=cale_dload)),:)=[data_dload(:,1) data_dloadStunden(:,end)];
ser_long={'Anzahl Arbeitnehmer','Ausgefallene Stunden'};

data_long_rt=zeros(length(cal_orig),size(data_dload,2)-2).*NaN;
data_long_rt((and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),:)=data_pdf(:,2*ones(1,size(data_dload,2)-2));
data_long_rt((and(cal_orig>=calb_dload,cal_orig<=cale_dload)),:)=data_dload(:,3:end);
%ser_long_rt={'Anzahl Arbeitnehmer'};





figure
% plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),(data_pdf(:,2)),'k')
% hold on
% plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),(data_dload(:,3)),'b')
% plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),(data_voranm),'r')
% legend('Settled SECO','Settled download','Pre-registerd SECO')
semilogy(cal_orig,data_long_orig(:,1),'b');
hold on
semilogy(cal_dload,sum(data_sect(:,1:end-1).*ser_weight(ones(1,218),:),2),'k')
legend('Absolute','FTE weighted')
V=axis;
axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
%fax= kron(ones(1,shadeC_no),[V(3);V(4);V(4);V(3)]);
%fill(shade_corona,fax,shadeC_color,'FaceAlpha',.2)
% plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),(data_pdf(:,2)),'k')
% plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),(data_dload(:,3)),'b')
% plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),(data_voranm),'r')
%plot(cal_orig,data_long_orig(:,1),'m');
legend('off')
legend('Absolute','FTE weighted')
figure
% plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),(data_pdf(:,2)),'k')
% hold on
% plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),(data_dload(:,3)),'b')
% plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),(data_voranm),'r')
% legend('Settled SECO','Settled download','Pre-registerd SECO')
semilogy(cal_dload,data_sect(:,end),'b')
hold on
semilogy(cal_dload,sum(data_sect(:,1:end-1).*ser_weight(ones(1,218),:),2),'k')
title('Number of employees, vintage 22M2')
V=axis;
axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
legend('Absolute','FTE-weighted')

'corr. levels'
corr(log(data_sect(:,end)),log(sum(data_sect(:,1:end-1).*ser_weight(ones(1,218),:),2)))
'corr. growth rates'
data_weighted=sum(data_sect(:,1:end-1).*ser_weight(ones(1,218),:),2);
corr(log(data_sect(2:end,end)./data_sect(1:end-1,end)),log(data_weighted(2:end,1)./data_weighted(1:end-1)))

figure
plot(cal_dload(2:end),[log(data_weighted(2:end,1)./data_weighted(1:end-1)),log(data_sect(2:end,end)./data_sect(1:end-1,end))])
legend('Weighted by FTE','Absolute')

% figure
% plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),(data_pdf(:,2)),'k')
% hold on
% plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),(data_dload(:,3)),'b')
% plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),(data_voranm),'r')
% %plot(cal_orig,log(data_long_orig(:,1)),'m');
% %plot(cal_bci(cal_bci>=cal_orig(1)),data_bci(cal_bci>=cal_orig(1)),'k')
% title('log number of short-time workers and SNB business cycle index')
% legend({'Settled SECO','Settled download','Pre-registered SECO'},'Location','NorthWest','FontSize',Flsize)
% ax1=gca;
% set(ax1,'Yscale','log')
% V=axis;
% %V(3)=-6;
% axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
% fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
% fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
% % plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),log(data_pdf(:,2)),'k')
% % plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),log(data_dload(:,3)),'b')
% % plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm),'r')
% % ax1=gca;
% % ax2=axes('Position',get(ax1,'Position'),'XAxisLocation','top','YAxisLocation','right','Color','none');
% % set(ax2,'XLim',[cal_orig(1)-x_lim cal_orig(end)+x_lim],'XTickLabel',' ','YLim',[V(3) V(4)]);
% % line(cal_bci(cal_bci>=cal_orig(1)),data_bci(cal_bci>=cal_orig(1)),'Parent',ax2,'Color','k')
% %     hold on
% %     line(cal_orig(end-ftl+1:end),zeros(size(ftstar,1),1),'Parent',ax2,'Color','k')

figure
%plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm))
plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),log(data_pdf(:,3)),'k')
hold on
plot(cal_orig,log(data_long_orig(:,2)),'b')
title('log ausgefallene Arbeitsstunden')
legend({'Abgerechnet pdf','Abgerechnet download'},'FontSize',Flsize)
V=axis;
axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
%plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm))
%plot(cal_orig(and(cal_orig>=calb_pdf,cal_orig<=cale_pdf)),log(data_pdf(:,3)),'k')
%plot(cal_orig(and(cal_orig>=calb_dload,cal_orig<=cale_dload)),log(data_dload(:,2)),'b')


figure
plot(cal_orig(2:end),log(data_long_orig(2:end,:)./data_long_orig(1:end-1,:)))
hold on
title('Growth rates (decimal), vintage 22M2')
legend({'Number of short-time workers','Lost working hours'},'Location','NorthWest','FontSize',Flsize)
V=axis;
axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)

corr(log(data_long_orig(cal_orig<=cale_dload,:)))

figure
%plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm))
plot(cal_bip,log(data_bip(:,end)))
hold on
title('log GDP, vintage 22Q1')
legend(ser_bip,'FontSize',Flsize)
V=axis;
V(3)=11.4;
axis([cal_orig(1)-x_lim cal_orig(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
%plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm))
%plot(cal_bip,log(data_bip))

figure
bip_grr=100*log(data_bip(2:end,end)./data_bip(1:end-1,end));
bip_grra=100*log(data_bip(5:end,end)./data_bip(1:end-4,end));
%bci_q=mean(reshape(data_bci(1:end-2),3,120))';
%cal_bciq=calb_bci(1):.25:2019.75;
plot(cal_bip(2:end),bip_grr,'k')
hold on
%plot(cal_bip(5:end),bip_grra,'b')
%plot(cal_bciq,bci_q,'r')
title('GDP growth rate, vintage 22Q1')
%legend([strcat(ser_bip(2),' q-o-q') , strcat(ser_bip(2), ' y-o-y'),  ser_bci],'Location','SouthWest')
%legend([strcat(ser_bip(1),' q-o-q')],'Location','NorthWest','FontSize',Flsize)
V=axis;
axis([cal_bip(1)-x_lim cal_bip(end)+x_lim V(3) V(4)]);
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
%plot(cal_orig(and(cal_orig>=calb_voranm,cal_orig<=cale_voranm)),log(data_voranm))
% plot(cal_bip(2:end),bip_grr,'k')
% plot(cal_bip(5:end),bip_grra,'b')
% plot(cal_bciq,bci_q,'r')

% 'corr between number of employess and snb bci'
% corr(log(data_long_orig(cal_orig<=cale_dload,1)),data_bci(and(cal_bci>=2000,cal_bci<=cale_dload),:))
figure
heatmap(data_sect(cal_dload>=2008.5,1:end-1)', [], [], [], 'Colormap','red','Colorlevels',100,'Colorbar','1')
figure
h=heatmap(log(data_sect(cal_dload>=2008.5,1:end-1)+(data_sect(cal_dload>=2008.5,1:end-1)==0).*exp(-4))', [cal_dload(cal_dload>=2008.5)], [], [], 'Colormap','red','Colorlevels',10,'Colorbar','1')
NewXLabel=h.Parent.XTickLabel(7:12:end);
NewXTick=h.Parent.XTick(7:12:end);
set(h.Parent,'XTick',NewXTick,'XTickLabel',NewXLabel);
set(h.Parent,'YTick',indYTick,'YTickLabel',indc_ser);


figure
bar3(cal_dload(cal_dload>=2009),data_sect(cal_dload>=2009,1:end-1))