rng(0)
%prior_info=0; %1 uses the mean posterior moments of a model estimate as prior moments
x_lim=6/12;
%
% if prior_info
%     cale_smpl=cale_smpl-12+9/12;
% end


ind_cal=~isnan(data_long_rt(:,cal_dvint==cale_smpl));
cal=cal_orig(ind_cal);%cal=cal_orig(cal_orig<(cale_smpl+5/12));
data_long=data_long_rt(ind_cal,cal_dvint==cale_smpl);


lnemp=log(data_long(:,1));
dlnemp=100*(lnemp(2:end)-lnemp(1:end-1));

[ac, hm, sd, med, ki, ineff] = autocovneu([lnemp(2:end-4),dlnemp(1:end-4)],50);
figure
bar(ac)
title('Log employees: Autocorrelation function')
legend('level','first difference')

%CHECK HERE
lags_ar=3;
const=1;
mdum=0; %flag to include month-effect of lagged quarterly gdp
calb_smpl=cal(lags_ar+1);%2001;
cale_smpl_o=cale_smpl;
cale_smpl=cal(end);
% if mdum;
%     calb_smpl=calb_smpl+1/4;
% end
%cale_smpl=2020+1/12;%2020;%2008+8/12; %SET END OF SAMPLE
calb_fore=cal(end)+1/12;%cale_smpl+1/12;
cal_smpl=cal(lags_ar+1:end);%cale_smpl;
cal_fore=calb_fore:1/12:cal(end)+1.5;%e_smpl+1.5;
cale_fore=cal_fore(end);

calb_fore2=cal(end)+1/12;
cal_fore2=calb_fore2:1/12:cal(end)+1.5;
cale_fore2=cal_fore2(end);

%Decide whether to aline the start of the scenario to the end of pseudo
%current-quarter available observations.
calb_scen=calb_fore;
cale_scen=cale_fore;%2021.5;
cal_scen=calb_scen:1/12:cale_scen;
T_scen=length(cal_scen);%-(length(cal)-length(cal(cal<(cale_smpl+1/12))));%fix(length(cal_scen)-(cal(end)-cale_smpl)*12);
scen_fac1= data_long(end,1)/data_long(cal==2009+4/12,1);
scen_fac2= data_long(end,1)/data_long(cal==2009+8/12,1);
data_scen=data_long(cal<(cale_scen+1/12),1);
%if ~prior_info
data_scen1=cat(1,data_scen,data_long(and(cal>2009+4/12,cal<2009+(5+(T_scen*(T_scen>0)))/12),1).*scen_fac1);
data_scen2=cat(1,data_scen,data_long(and(cal>2009+8/12,cal<=2009+(8+(T_scen*(T_scen>0)))/12),1).*scen_fac2);
%elseif prior_info
%    data_scen1=data_long_orig(cal_orig<(cale_scen+1/12),1);
%    data_scen2=data_long_orig(cal_orig<(cale_scen+1/12),1);
%end
cal_lscen=cal(1):1/12:cale_scen;

Jfor=length(cal_fore);

MC=3000;
it0=1000;
Mmc=MC-it0;

Y=lnemp;%(cal<(cale_smpl+1/12));
Y1step_dep=log(data_long_orig(cal_orig<(cale_fore+1/12),1));
cal_1step=cal_orig(cal_orig<(cale_fore+1/12));

Yscen1_dep=log(data_scen1);
Yscen2_dep=log(data_scen2);

X=[];
X1step=[];
Xscen1=[];
Xscen2=[];
xlab=[];
ser='ar_{';
for j=1:lags_ar
    X=cat(2,X,Y(lags_ar+1-j:end-j));
    X1step=cat(2,X1step,Y1step_dep(lags_ar+1-j:end-j));
    Xscen1=cat(2,Xscen1,Yscen1_dep(lags_ar+1-j:end-j));
    Xscen2=cat(2,Xscen2,Yscen2_dep(lags_ar+1-j:end-j));
    xlab=cat(1,xlab,{strcat(ser,int2str(j),'}')});
end
if const
    X=cat(2,ones(size(X,1),1),X);
    X1step=cat(2,ones(size(X1step,1),1),X1step);
    Xscen1=cat(2,ones(size(Xscen1,1),1),Xscen1);
    Xscen2=cat(2,ones(size(Xscen2,1),1),Xscen2);
    xlab=cat(1,'intercept',xlab);
end
T=length(cal_smpl);
Y=Y(end-T+1:end);
% cal_smpl=cal_smpl(end-T+1:end);
% calb_smpl=cal_smpl(1);
% cale_smpl=cal_smpl(end);
X=X(end-T+1:end,:);
pind_arn=1+const:size(X,2);

if mdum
    start_dat=fix(calb_smpl)+floor((calb_smpl-fix(calb_smpl))*4)/4-.5;
    el_bip=find(cal_bip(2:end)>=start_dat);
    %Xm=kron(bip_grr(el_bip(1:ceil(T/3))),eye(3));
    Xm=kron(bip_grr(el_bip(1:ceil(T/3))),ones(3,1));
    xmrow=mod(((cal_smpl(1)-fix(cal_smpl(1)))*12+1),3);
    xmrow=(xmrow==0)*3+xmrow;
    Xm=Xm(xmrow:xmrow+(T-1),:);
    X=cat(2,X,Xm);
    xlab=cat(1,xlab,'m1','m2','m3');
end

n_parms=size(X,2);
if ~prior_info
    coeff_arprm=zeros(n_parms,1);
    coeff_arprinf=zeros(n_parms);
    sig_g0=1;
    sig_G0=1;
    sig=1;
end

if and(prior_info,ical==2)
    coeff_arprm=mean(coeff_arpommc,2);
    coeff_arprinf=mean(coeff_arpoinfmc,3);
    sig_g0=3;%mean(sig_garmc);
    sig_G0=mean(sig_Garmc);
end


coeff_arpoinf=((X'*X)./sig+coeff_arprinf);
coeff_arpom=coeff_arpoinf\((X'*Y)./sig+coeff_arprinf*coeff_arprm);
coeff=coeff_arpom;
sig_armc=zeros(1,Mmc);
coeff_armc=zeros(n_parms,Mmc);
coeff_arpommc=zeros(n_parms,Mmc);
coeff_arpoinfmc=zeros(n_parms,n_parms,Mmc);
sig_garmc=zeros(1,Mmc);
sig_Garmc=zeros(1,Mmc);

for j=1:MC
    
    sig_g=sig_g0+.5*T;
    sig_G=sig_G0+.5*sum((Y-X*coeff).^2);
    
    sig=(gamrnd(sig_g,1./sig_G)).^(-1);
    
    coeff_arpoinf=((X'*X)./sig+coeff_arprinf);
    coeff_arpom=coeff_arpoinf\((X'*Y)./sig+coeff_arprinf*coeff_arprm);
    
    coeff=coeff_arpom+chol(coeff_arpoinf)\randn(n_parms,1);
    if j>it0
        sig_armc(1,j-it0)=sig;
        coeff_armc(:,j-it0)=coeff;
        sig_garmc(1,j-it0)=sig_g;
        sig_Garmc(1,j-it0)=sig_G;
        coeff_arpommc(:,j-it0)=coeff_arpom;
        coeff_arpoinfmc(:,:,j-it0)=coeff_arpoinf;
    end
end

Yfit=X*coeff_armc;
Yres=Y(:,ones(1,Mmc))-Yfit;
Yfor=zeros(Jfor,Mmc);
Yfor2=zeros(Jfor,Mmc);
['(variance estimate) R^2=' num2str(mean(1-sig_armc./var(Y)),'%5.2f')]
['(error variance) R^2=' num2str(mean(1-var(Yres)./var(Y)),'%5.2f')]
['SIC(' int2str(lags_ar) ')=' num2str(log(mean(sig_armc))+n_parms*log(T)/T,'%5.2f')]
['AIC(' int2str(lags_ar) ')=' num2str(log(mean(sig_armc))+n_parms*2/T,'%5.2f')]

if ~mdum
    for j=1:Jfor
        if j==1
            Xfor=cat(2,X(end,1),Y(end),X(end,2:end-1));
            Yfor(1,:)=Xfor*coeff_armc;
            Xfor=Xfor(ones(1,Mmc),:);
            
            Xfor2=cat(2,1,lnemp(end:-1:end-lags_ar+1)');
            Yfor2(1,:)=Xfor2*coeff_armc;
            Xfor2=Xfor2(ones(1,Mmc),:);
        else
            Xfor=cat(2,Xfor(:,1),Yfor(j-1,:)',Xfor(:,2:end-1));
            Yfor(j,:)=diag(Xfor*coeff_armc);
            
            Xfor2=cat(2,Xfor2(:,1),Yfor2(j-1,:)',Xfor2(:,2:end-1));
            Yfor2(j,:)=diag(Xfor2*coeff_armc);
        end
    end
    
    Y1step=X1step*coeff_armc;
    cal_1step=cal_1step(end-size(Y1step,1)+1:end);
    calb_1step=cal_1step(1);
    cale_1step=cal_1step(end);
    Yres_1step=Y1step_dep(lags_ar+1:end,ones(1,Mmc))-Y1step;
    
    Yscen1=Xscen1*coeff_armc;
    cal_lscen=cal_lscen(end-size(Yscen1,1)+1:end);
    calb_lscen=cal_lscen(1);
    cale_lscen=cal_lscen(end);
    Yres_scen1=Yscen1_dep(lags_ar+1:end,ones(1,Mmc))-Yscen1;
    Yscen2=Xscen2*coeff_armc;
    Yres_scen2=Yscen2_dep(lags_ar+1:end,ones(1,Mmc))-Yscen2;
    
    
end
index=1:100:size(Yfit,2);
figure(10)
plot(cal,lnemp,'r','LineWidth',2)
hold on
plot(cal_smpl,Yfit(:,index),'b')
legend('log short-hour employees','fitted')
plot(cal,lnemp,'r','LineWidth',2)

figure(11)
plot(cal,lnemp,'r')
hold on
plot(cal_smpl,mean(Yfit,2),'b')
legend({'Data','Mean fitted value'},'Location','NorthWest','FontSize',Flsize)
V=axis;
V(3)=-5;
axis([cal(1)-x_lim cal(end)+x_lim V(3) V(4)]);
ax1=gca;
ax2=axes('Position',get(ax1,'Position'),'XAxisLocation','top','YAxisLocation','right','Color','none');
set(ax2,'XLim',[cal(1)-x_lim cal(end)+x_lim],'XTickLabel',' ','YLim',[V(3) V(4)]);
line(cal_smpl,Yres,'Parent',ax2,'Color','b')
hold on
line(cal_smpl,mean(Yres,2),'Parent',ax2,'Color','r','LineWidth',2)
line(cal_smpl,zeros(length(cal_smpl),1),'Parent',ax2,'Color','w')
line(cal_smpl,[-2*sqrt(mean(sig_armc))*ones(length(cal_smpl),1) 2*sqrt(mean(sig_armc))*ones(length(cal_smpl),1)],'Parent',ax2,'Color','k')
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)


if ~mdum
    figure(12)
    plot(cal_1step,Yres_1step(:,index),'g')
    hold on
    plot(cal_smpl,Yres(:,index),'b')
    hold on
    plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
    plot(cal_1step,mean(Yres_1step,2),'Color','r','LineWidth',2)
    plot(cal_smpl,zeros(length(cal_smpl),1),'w')
    title('One-step ahead error: In-sample (blue), end-revised (green), mean (red)')
    V=axis;
    fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
    fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
    axis([fix(cale_smpl)-1 cal_1step(end)+x_lim V(3:4)])
    
    if ~prior_info
        figure(13)
        plot(cal_lscen,Yres_scen1(:,index),'m')
        hold on
        plot(cal_1step,Yres_1step(:,index),'g')
        plot(cal_smpl,Yres(:,index),'b')
        hold on
        plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
        plot(cal_lscen,mean(Yres_scen1,2),'Color','r','LineWidth',2)
        plot([cal cal_scen],zeros(length(cal)+length(cal_scen),1),'w')
        title('One-step ahead (scen1): In-sample (blue), end-revised (green and magenta), mean (red)')
        V=axis;
        fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
        fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
        axis([fix(cale_smpl)-1 cal_1step(end)+x_lim V(3:4)])
        
        figure(14)
        plot(cal_lscen,Yres_scen2(:,index),'m')
        hold on
        plot(cal_1step,Yres_1step(:,index),'g')
        plot(cal_smpl,Yres(:,index),'b')
        hold on
        plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
        plot(cal_lscen,mean(Yres_scen2,2),'Color','r','LineWidth',2)
        plot([cal cal_scen],zeros(length(cal)+length(cal_scen),1),'w')
        title('One-step ahead (scen2): In-sample (blue), end-revised (green and magenta), mean (red)')
        V=axis;
        fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
        fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
        axis([fix(cale_smpl)-1 cal_1step(end)+x_lim V(3:4)])
    end
end

figure(15)
plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
hold on
plot(cal_smpl,zeros(length(cal_smpl),1),'w')
title('Mean in-sample residuals')
V=axis;
axis([cal_smpl(1)-x_lim cal_smpl(end)+x_lim V(3:4)])
% Yres_95  = hpdi_max(Yres',0.95)';
% Yres_60 = hpdi_max(Yres',.6)';
% jbfill(cal_smpl,Yres_95(:,1)',Yres_95(:,2)',[0 0 1], [0 0 1], 1, .2);
% axis([cal_smpl(1)-x_lim cal_smpl(end)+x_lim min(Yres_95(:))-.2 max(Yres_95(:))+.2])
% V=axis;
% ind_sig=~(~sum(sign(Yres_95),2));
% hold on
% bar(cal_smpl(ind_sig),V(3)*ones(sum(ind_sig),1))
% bar(cal_smpl(ind_sig),V(4)*ones(sum(ind_sig),1))
fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)


if ~mdum
    if ~prior_info
        figure(16)
        plot(cal,lnemp,'r')
        hold on
        plot(cal_smpl,mean(Yfit,2),'b')
        plot([cal(end) cal_fore],cat(1,Y(end),mean(Yfor,2)),'k')
        plot(cal_scen(end-T_scen+(T_scen==length(cal_scen)):end),log(data_scen1(end-T_scen+(T_scen==length(cal_scen)):end)),'m')
        plot(cal_scen(end-T_scen+(T_scen==length(cal_scen)):end),log(data_scen2(end-T_scen+(T_scen==length(cal_scen)):end)),'m')
        plot([cal(end) cal_fore2],cat(1,lnemp(end),mean(Yfor2,2)),'k')
        legend({'data','mean fitted value','mean dynamic forecast','scenario-based forecast'},'Location','NorthWest','FontSize',Flsize)
        % plot(cal(end-Jfor:end),cat(1,Y(end*ones(1,Mmc))',Yfor),'b')
        V=axis;
        axis([cal(1)-x_lim cale_fore2+x_lim V(3) V(4)]);
        fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
        fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
        fore_95  = hpdi_max(cat(1,Y(end*ones(1,Mmc))',Yfor)',0.95)';
        jbfill([cale_smpl cal_fore],fore_95(:,1)',fore_95(:,2)',shade_color, shade_color, 1, Fvalue);
        fore2_95  = hpdi_max(cat(1,lnemp(end*ones(1,Mmc))',Yfor2)',0.95)';
        jbfill([cal(end) cal_fore2],fore2_95(:,1)',fore2_95(:,2)',shade_color, shade_color, 1, Fvalue);
        V=axis;
        %axis([fix(cale_smpl)-3 cale_fore2(end)+x_lim V(3:4)])
        axis([2008 cale_fore2(end)+x_lim V(3:4)])
        
        figure(17)
        plot(cal,lnemp,'r')
        hold on
        plot(cal_smpl,mean(Yfit,2),'b')
        plot([cal(end) cal_fore2],cat(1,lnemp(end),mean(Yfor2,2)),'k')
        %plot(cal_scen(end-T_scen:end),log(data_scen1(end-T_scen:end)),'m')
        plot(cal_scen(end-T_scen+(T_scen==length(cal_scen)):end),log(data_scen2(end-T_scen+(T_scen==length(cal_scen)):end)),'m')
        %plot([cale_smpl cal_fore],cat(1,Y(end),median(Yfor,2)),'k')
        % plot(cal_1step,Yres_1step,'g')
        % plot(cal_smpl,Yres,'b')
        % plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
        % plot(cal_1step,mean(Yres_1step,2),'Color','r','LineWidth',2)
        % plot([cal(end) cal_fore2],zeros(size(Yfor2,1)+1),'r','LineWidth',2)
        % plot(cal_smpl,zeros(length(cal_smpl),1),'w')
        legend({'data','mean fitted value','mean dynamic forecast','financial crisis decline'},'Location','NorthWest','FontSize',Flsize)
        % plot(cal(end-Jfor:end),cat(1,Y(end*ones(1,Mmc))',Yfor),'b')
        V=axis;
        axis([cal(1)-x_lim cale_fore2+x_lim V(3) V(4)]);
        fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
        fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
        % fore_95  = hpdi_max(cat(1,Y(end*ones(1,Mmc))',Yfor)',0.95)';
        % jbfill([cale_smpl cal_fore],fore_95(:,1)',fore_95(:,2)',shade_color, shade_color, 1, Fvalue);
        fore2_95  = hpdi_max(cat(1,lnemp(end*ones(1,Mmc))',Yfor2)',0.95)';
        jbfill([cal(end) cal_fore2],fore2_95(:,1)',fore2_95(:,2)',shade_color, shade_color, 1, Fvalue);
        V=axis;
        %axis([fix(cale_smpl)-3 cale_fore2(end)+x_lim V(3:4)])
        axis([2008 cale_fore2(end)+x_lim V(3:4)])
        
        figure(18)
        plot(cal,lnemp,'r')
        hold on
        plot(cal_smpl,mean(Yfit,2),'b')
        plot([cal(end) cal_fore2(cal_fore2<=cale_fore)],cat(1,lnemp(end),mean(Yfor2((cal_fore2<=cale_fore),:),2)),'k')
        %plot(cal_scen(end-T_scen:end),log(data_scen1(end-T_scen:end)),'m')
        plot(cal_scen(end-T_scen+(T_scen==length(cal_scen)):end),log(data_scen2(end-T_scen+(T_scen==length(cal_scen)):end)),'m')
        hold on
        %plot([cale_smpl cal_fore],cat(1,Y(end),median(Yfor,2)),'k')
        plot(cal_1step,Yres_1step,'g')
        plot(cal_smpl,Yres,'b')
        plot(cal_smpl,mean(Yres,2),'Color','r','LineWidth',2)
        plot(cal_1step,mean(Yres_1step,2),'Color','r','LineWidth',2)
        plot(cal(end):1/12:cale_fore,zeros(length(cal(end):1/12:cale_fore),1),'r','LineWidth',2)
        plot(cal_smpl,zeros(length(cal_smpl),1),'w')
        legend({'data','mean fitted value','mean dynamic forecast','financial crisis decline'},'Location','NorthWest','FontSize',Flsize)
        % plot(cal(end-Jfor:end),cat(1,Y(end*ones(1,Mmc))',Yfor),'b')
        V=axis;
        axis([cal(1)-x_lim cale_fore2+x_lim V(3) V(4)]);
        fax= kron(ones(1,shade_no),[V(3);V(4);V(4);V(3)]);
        fill(shade_events,fax,shade_color,'FaceAlpha',Fvalue)
        % fore_95  = hpdi_max(cat(1,Y(end*ones(1,Mmc))',Yfor)',0.95)';
        % jbfill([cale_smpl cal_fore],fore_95(:,1)',fore_95(:,2)',shade_color, shade_color, 1, Fvalue);
        fore2_95  = hpdi_max(cat(1,lnemp(end*ones(1,Mmc))',Yfor2(cal_fore2<=cale_fore,:))',0.95)';
        jbfill([cal(end) cal_fore2(cal_fore2<=cale_fore)],fore2_95(:,1)',fore2_95(:,2)',shade_color, shade_color, 1, Fvalue);
        V=axis;
        %axis([fix(cale_smpl)-3 cale_fore2(end)+x_lim V(3:4)])
        axis([2018 cale_fore(end)+x_lim V(3:4)])
    end
    
    
    % 'correlation GDP, shocks: '
    % corr(bip_grr(81:end),sum(Yres_mq(end-length(bip_grr):end-1,:),2))
    
    Yres_m=mean(Yres,2);
    % Yres_indsig95=~(~sum(sign(Yres_95),2));
    % Yres_indsig60=~(~sum(sign(Yres_60),2));
    Yfore_shock50=Y1step_dep(end-Jfor+1:end)-median(Yfor,2);
    Yfore_shock95=Y1step_dep(end-Jfor+1:end)-fore_95(2:end,2);
    
    T_q=(fix(cale_smpl)+1-fix(calb_smpl))*4;
    cal_smplq=fix(calb_smpl):1/4:fix(cale_smpl)+.75;
    T_b=12-sum(fix(cal_smpl)==fix(calb_smpl));
    T_e=12-sum(fix(cal_smpl)==fix(cale_smpl));
    Yres_mq=reshape(cat(1,zeros(T_b,1),Yres_m,zeros(T_e,1)),3,T_q)';
    cal_smplq=cal_smplq(~all(Yres_mq==0,2));
    Yres_mq=Yres_mq(~all(Yres_mq==0,2),:);
    
    
    T1step_q=(fix(cale_1step)+1-fix(calb_1step))*4;
    cal_1stepq=fix(calb_1step):1/4:fix(cale_1step)+.75;
    T1step_b=12-sum(fix(cal_1step)==fix(calb_1step));
    T1step_e=12-sum(fix(cal_1step)==fix(cale_1step));
    Yres_1stepmq=reshape(cat(1,zeros(T1step_b,1),mean(Yres_1step,2),zeros(T1step_e,1)),3,T1step_q)';
    cal_1stepq=cal_1stepq(~all(Yres_1stepmq==0,2));
    Yres_1stepmq=Yres_1stepmq(~all(Yres_1stepmq==0,2),:);
    
    
    figure(19)
    plot(cal_1stepq,sum(Yres_1stepmq,2),'r')
    hold on
    plot(cal_bip(2:end),bip_grr,'b')
    legend({'Shocks cumulated within-quarter','GDP growth'},'Location','NorthWest','FontSize',Flsize)
    V=axis;
    axis([cal_1stepq(1)-.25 cal_1stepq(end)+.25 V(3) V(4)]);
    
end

nr=3;
nc=3;
nsub=nr*nc;
ngr=ceil((n_parms+1)/(nr*nc));
for j=1:ngr
    figure(20+j-1)
    for k=1:nsub
        if (j-1)*nsub+k<=n_parms
            subplot(nr,nc,k)
            [f,x]=ksdensity(coeff_armc((j-1)*nsub+k,:)');
            plot(x,f)
            xlabel(xlab{(j-1)*nsub+k})
        elseif (j-1)*nsub+k==n_parms+1
            subplot(nr,nc,k)
            [f,x]=ksdensity(sum(coeff_armc(pind_arn,:),1)');
            plot(x,f)
            xlabel('sum ar coeffs')
        else
            break
        end
        
    end
end

[ac, hm_ar, sd, med, ki_ar, ineff] = autocovneu([coeff_armc',sum(coeff_armc(pind_arn,:),1)',sig_armc'],100);
[ac, hm_arr2, sd, med, ki_arr2, ineff] = autocovneu((1-var(Yres)./var(Y))',100);

[hm_ar ki_ar]


cale_smpl=cale_smpl_o;

%pause
%close all