rng(0)
%prior_info=0; %1 posterior moment means of a model estimate as prior moments
MC=4000;
it0=1000;
Mmc=MC-it0;
lags_y=2;
lags_shock=ical-1;
lags_regr=max(lags_y,lags_shock);

const=1;
dum=1;

freq=4;

% dbci=data_bci(2:end)-data_bci(1:end-1);
% calb_dbci=calb_bci+1/freq;
% cal_dbci=calb_dbci:1/freq:cale_bci;


calb_dep=calb_bip+1/freq;
cale_dep=cale_bip(end);
cal_dep=calb_dep:1/freq:cale_dep;
calb_ex=cal_smplq(1);
cale_ex=cal_smplq(end);
cal_ex=calb_ex:1/freq:cale_ex;

calb_smplreg=max(calb_dep,calb_ex);
%cale_smplreg=2019.75;%min(cale_dep,cale_ex);
cal_smplreg=calb_smplreg:1/freq:cale_smplreg;

bip_grr=log(data_bip(:,cal_bipvint==tbipvint));
bip_grr=100*(bip_grr(2:end)-bip_grr(1:end-1));
Yreg=bip_grr(and(cal_dep>=calb_smplreg,cal_dep<=cale_smplreg));
X_shock=sum(Yres_mq(and(cal_ex>=calb_smplreg,cal_ex<=cale_smplreg),:),2);

Xregr=X_shock(lags_regr+1-lags_shock:end-lags_shock);
xlab=[];
ser='shock_{';
for j=(lags_shock-1:-1:0);%(0:lags_shock)+cali-1
    Xregr=Xregr+X_shock(lags_regr+1-j:end-j);%cat(2,Xregr,X_shock(lags_regr+1-j:end-j));
    
end
xlab=cat(1,xlab,{strcat(ser,int2str(j),'}')});
if const
    Xregr=cat(2,ones(size(Yreg,1)-lags_regr,1),Xregr);
    xlab=cat(1,'intercept',xlab);
end
pind_shock=const+1:size(Xregr,2);
ser='ar_{';
pind_dep=size(Xregr,2)+1;
for j=1:lags_y
    Xregr=cat(2,Xregr,Yreg(lags_regr+1-j:end-j));
    xlab=cat(1,xlab,{strcat(ser,int2str(j),'}')});
end
pind_dep=pind_dep(1):pind_dep(1)+lags_y-1;
Yreg=Yreg(lags_regr+1:end);
T=size(Yreg,1);
cal_smplreg=cal_smplreg(end-T+1:end);
calb_smplreg=cal_smplreg(1);
cale_smplreg=cal_smplreg(end);

ser='D_{'
if dum
    Dk=kron(ones(ceil(T/freq)+1,1),eye(freq,freq-1));
    sh=freq-((cale_smplreg-fix(cale_smplreg))*freq+1);
    Dk=Dk(end-sh-T+1:end-sh,:);
    Xregr=cat(2,Xregr,Dk);
    for j=1:freq-1
        xlab=cat(1,xlab,{strcat(ser,int2str(j),'}')});
    end
end

n_parms=size(Xregr,2);
if ~prior_info
coeff_regrprm=zeros(n_parms,1);
coeff_regrprinf=zeros(n_parms);

sig_regrg0=1;
sig_regrG0=1;
sig=1;
end

if and(prior_info,ical==2)
    coeff_regrprm=mean(coeff_regrpommc,2);
    coeff_regrprinf=mean(coeff_regrpoinfmc,3);
    sig_regrg0=3;%mean(sig_gregrmc);
    sig_regrG0=mean(sig_Gregrmc);
end

coeff_regrpoinf=(Xregr'*Xregr./sig+coeff_regrprinf);
coeff_regrpom=coeff_regrpoinf\(Xregr'*Yreg./sig+coeff_regrprinf*coeff_regrprm);

coeff=coeff_regrpom;
sig_regrmc=zeros(1,Mmc);
coeff_regrmc=zeros(n_parms,Mmc);
coeff_regrpommc=zeros(n_parms,Mmc);
coeff_regrpoinfmc=zeros(n_parms,n_parms,Mmc);
sig_gregrmc=zeros(1,Mmc);
sig_Gregrmc=zeros(1,Mmc);

for j=1:MC
    sig_g=sig_regrg0+.5*T;
    sig_G=sig_regrG0+.5*sum((Yreg-Xregr*coeff).^2);
    
    sig=(gamrnd(sig_g,1./sig_G)).^(-1);
    coeff_regrpoinf=(Xregr'*Xregr./sig+coeff_regrprinf);
    coeff_regrpom=coeff_regrpoinf\(Xregr'*Yreg./sig+coeff_regrprinf*coeff_regrprm);
    coeff=coeff_regrpom+chol(coeff_regrpoinf)\randn(n_parms,1);
    
    if j>it0
        sig_regrmc(1,j-it0)=sig;
        coeff_regrmc(:,j-it0)=coeff;
        sig_gregrmc(1,j-it0)=sig_g;
        sig_Gregrmc(1,j-it0)=sig_G;
        coeff_regrpommc(:,j-it0)=coeff_regrpom;
        coeff_regrpoinfmc(:,:,j-it0)=coeff_regrpoinf;

    end
    
end
['(variance estimate) R^2= ' num2str(mean(1-sig_regrmc./var(Yreg)),'%5.2f')]
Yres_reg=Yreg(:,ones(1,Mmc))-Xregr*coeff_regrmc;
['(error variance) R^2= ' num2str(mean(1-var(Yres_reg)./var(Yreg)),'%5.2f')]

nr=3;
nc=3;
nsub=nr*nc;
ngr=ceil((n_parms+3)/(nr*nc));
for j=1:ngr
    figure(30+j-1)
    for k=1:nsub
        if (j-1)*nsub+k<=n_parms
            subplot(nr,nc,k)
            [f,x]=ksdensity(coeff_regrmc((j-1)*nsub+k,:)');
            plot(x,f)
            xlabel(xlab{(j-1)*nsub+k})
        elseif (j-1)*nsub+k==n_parms+1
            subplot(nr,nc,k)
            [f,x]=ksdensity(sum(coeff_regrmc(pind_shock,:),1)');
            plot(x,f)
            xlabel('sum shock coeffs')
        elseif (j-1)*nsub+k==n_parms+2
            subplot(nr,nc,k)
            [f,x]=ksdensity(sum(coeff_regrmc(pind_dep,:),1)');
            plot(x,f)
            xlabel('sum ar coeffs')
        elseif (j-1)*nsub+k==n_parms+3
            subplot(nr,nc,k)
            [f,x]=ksdensity((sum(coeff_regrmc(pind_shock,:),1)./(1-sum(coeff_regrmc(pind_dep,:),1)))');
            plot(x,f)
            xlabel('long-run shock effect')
        else
            break
        end
        
    end
end
figure(40)
[f,x]=ksdensity(sig_regrmc');
plot(x,f)
xlabel('error variance')

figure(41)
plot(cal_smplreg,Xregr(:,2))
hold on

figure(42)
[f,x]=ksdensity(coeff_regrmc(2,:)');
plot(x,f)
hold on

if ical==icale
    %legend(num2str(fstart','%5.2f'))
    legend(strfstart)
end
    

[ac, hm_regr, sd, med, ki_regr, ineff_regr] = autocovneu([coeff_regrmc',sum(coeff_regrmc(pind_dep,:),1)',sum(coeff_regrmc(pind_shock,:),1)',... 
    (sum(coeff_regrmc(pind_shock,:),1)./(1-sum(coeff_regrmc(pind_dep,:),1)))',sig_regrmc'],100);
[ac, hm_regrr2, sd, med, ki_regrr2, ineff] = autocovneu((1-var(Yres_reg)./var(Yreg))',100);

regrcoeff_stats(1:length(hm_regr),:,ical)=[hm_regr ki_regr];
[hm_regr ki_regr]
%pause
%close all