f1=fopen('forecast.txt','a');
Iscen=[1];
ical=0;
fstart=[2020:.25:cal_dvint(end-1)];
icale=length(fstart);
strfstart={'20Q1-M4';'20Q2';'20Q3';'20Q4';'21Q1';'21Q2';'21Q3';'21Q4';'22Q1';'Data'};
shockmat=zeros(8,length(fstart));
forecast_gr=zeros(9,4,icale,3); %date,mean,95HPDI , scen 1,2,3
forecast_grcum=zeros(9,4,icale,3);
forecast_gdp=zeros(21,4,icale,3);
forecast_gdpmc=zeros(21,2,icale,3,3000);
regrcoeff_stats=zeros(17,3,icale);
forecastfincr_gr=zeros(9,4,icale,3); %date,mean,95HPDI , scen 1,2,3
forecastfincr_grcum=zeros(9,4,icale,3);
forecastfincr_gdp=zeros(10,4,icale,3);
for cale_smpl=[2020+3/12 2020+5/12:.25:cal_dvint(end)]

    icale=length(fstart);
    tbipvint=max(cal_bipvint(cal_bipvint<=cale_smpl-2/12));
    ical=ical+1;
    prior_info=0;
%     if ical>1
%         prior_info=1;
%     end
    data_analysis_rolling_update_rt
    cale_smplreg=2019.75;%cale_smpl-mod(cale_smpl,.25)-.25;
    regression_analysis_lagcumshocks_update_rt
    impulse_forecast_lagcumshocks_update_rt
   % pause
   if and(~prior_info,ical~=icale)
    close 1 10 11 12 13 14 15 16 17 18 19 20 30 40
%      prior_info=1;
%      data_analysis_rolling_update
%      cale_smplreg=cale_smpl-mod(cale_smpl,.25)-.25;
%      regression_analysis_update
%      impulse_forecast_update
% %    % pause
%    else
%       close 1 10 11 12 19 20 30 31 40
   end
end

figure(54)
legend('off')
legend(strfstart)

bip_annual=[];

for ifreq=freqf:-1:1
    bip_annual=cat(5,bip_annual,forecast_gdp(ifreq:end-(freqf-ifreq),2:end,:,1));
end
bip_annual=cat(2,forecast_gdp(4:end,1,:,1),log(sum(exp(bip_annual),5)));
ind_ann=(bip_annual(5:end,1,:)-fix(bip_annual(5:end,1,:)))==.75;
'annual growth rates'
bipgr_annual=[bip_annual(5:end,1,:)./1000 (bip_annual(5:end,2:end,:)-bip_annual(1:end-4,2:end,:)).*100];
ind_ann=cat(1,ones(1,1,length(fstart)),ind_ann);
bipgr_annual=cat(1,[permute(fstart,[1 3 2])./1000,zeros(1,3,length(fstart))],bipgr_annual);
bipgr_annual.*ind_ann(:,ones(1,4),:)
'matrix of shocks'
cat(2,cat(1,fstart./1000,shockmat,sum(shockmat)),[0;fstart'./1000;0])
h=figure
bar(fstart',shockmat)
%legend(num2str(fstart','%5.2f'))
legend(strfstart(1:end-1))
hold on
%for j=1:length(fstart)
scatter(fstart',sum(shockmat),'o','filled')
%hold on
%end
legend('off')
legend(strfstart(1:end-1))
fclose(f1);

bipmc_annual=[];
bipgr2_annual=zeros(size(bipgr_annual));
for ifreq=freqf:-1:1
    bipmc_annual=cat(6,bipmc_annual,forecast_gdpmc(ifreq:end-(freqf-ifreq),2:end,:,1,:));
end
bipmc_annual=cat(2,forecast_gdpmc(4:end,1,:,1,:),log(sum(exp(bipmc_annual),6)));
bipgrmc_annual=[bipmc_annual(5:end,1,:,1,:)./1000 (bipmc_annual(5:end,2:end,:,1,:)-bipmc_annual(1:end-4,2:end,:,1,:)).*100];
for j=1:size(forecast_gdpmc,3)
    biggr_95  = hpdi_max(permute(bipgrmc_annual(:,2,j,1,:),[5 1 2 3 4]),0.95);
    bipgr2_annual(:,:,j)=cat(1,[fstart(j)./1000,zeros(1,3)],cat(2,bipgrmc_annual(:,1,j,1),mean(bipgrmc_annual(:,2,j,1,:),5),biggr_95'));
end
bipgr2_annual.*ind_ann(:,ones(1,4),:)